"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.Logout = exports.Login = void 0;
var axios_1 = __importDefault(require("axios"));
var nedb_1 = __importDefault(require("nedb"));
var open_1 = __importDefault(require("open"));
var prompts_1 = __importDefault(require("prompts"));
var fs_1 = __importDefault(require("fs"));
var configs_json_1 = require("../configs/configs.json");
var getOauthToken = function () { return __awaiter(void 0, void 0, void 0, function () {
    var request, _a, oauthToken, oauthTokenSecret, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(configs_json_1.middlewareUrl + "/getOauthToken")];
            case 1:
                request = _b.sent();
                _a = request.data, oauthToken = _a.oauthToken, oauthTokenSecret = _a.oauthTokenSecret;
                return [2 /*return*/, { oauthToken: oauthToken, oauthTokenSecret: oauthTokenSecret }];
            case 2:
                err_1 = _b.sent();
                throw new Error(err_1.message);
            case 3: return [2 /*return*/];
        }
    });
}); };
var getAccessToken = function (oauthToken, oauthTokenSecret, oauthVerifier) { return __awaiter(void 0, void 0, void 0, function () {
    var request, _a, accessToken, accessTokenSecret, err_2;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(configs_json_1.middlewareUrl + "/getAccessToken", {
                        oauth_token: oauthToken,
                        oauth_token_secret: oauthTokenSecret,
                        oauth_verifier: oauthVerifier
                    })];
            case 1:
                request = _b.sent();
                _a = request.data, accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret;
                return [2 /*return*/, { accessToken: accessToken, accessTokenSecret: accessTokenSecret }];
            case 2:
                err_2 = _b.sent();
                throw new Error(err_2.message);
            case 3: return [2 /*return*/];
        }
    });
}); };
var userInput = function () { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, _a, oauthVerifier, userName, err_3;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                onCancel = function () {
                    console.error('Error: 入力内容が確認できませんでした...もう一度最初から入力してください。');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'text',
                            name: 'oauthVerifier',
                            message: 'ブラウザに表示されたトークンを入力してください',
                            validate: function (value) { return (!value ? '何か入力してください' : true); }
                        },
                        {
                            type: 'text',
                            name: 'userName',
                            message: '表示名を入力してください',
                            validate: function (value) { return (!value ? '何か入力してください' : true); }
                        }
                    ], { onCancel: onCancel })];
            case 1:
                _a = _b.sent(), oauthVerifier = _a.oauthVerifier, userName = _a.userName;
                return [2 /*return*/, { oauthVerifier: oauthVerifier, userName: userName }];
            case 2:
                err_3 = _b.sent();
                throw new Error(err_3.message);
            case 3: return [2 /*return*/];
        }
    });
}); };
var setDb = function (db, accessToken, accessTokenSecret, userName) { return __awaiter(void 0, void 0, void 0, function () {
    var err_4;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, db.update({
                        selected: true
                    }, {
                        $set: {
                            selected: false
                        }
                    }, {
                        multi: true
                    }, function (error) {
                        if (!error) {
                            var data = {
                                type: 'user',
                                name: userName,
                                accessToken: accessToken,
                                accessTokenSecret: accessTokenSecret,
                                selected: true
                            };
                            db.insert(data, function () {
                                console.log("\u3088\u3046\u3053\u305D\u3001" + userName + "!");
                            });
                        }
                        else {
                            throw new Error('database登録時にエラーがあったようです...もう一度ログインを試してみてください');
                        }
                    })];
            case 1:
                _a.sent();
                return [3 /*break*/, 3];
            case 2:
                err_4 = _a.sent();
                throw new Error(err_4.message);
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.Login = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, oauthToken, oauthTokenSecret, _b, oauthVerifier, userName, _c, accessToken, accessTokenSecret, e_1;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _d.trys.push([0, 10, , 11]);
                return [4 /*yield*/, getOauthToken()];
            case 1:
                _a = _d.sent(), oauthToken = _a.oauthToken, oauthTokenSecret = _a.oauthTokenSecret;
                if (!(oauthToken && oauthTokenSecret)) return [3 /*break*/, 3];
                return [4 /*yield*/, open_1["default"](configs_json_1.callbackUrl + "/authenticate?oauth_token=" + oauthToken)];
            case 2:
                _d.sent();
                return [3 /*break*/, 4];
            case 3: return [2 /*return*/];
            case 4: return [4 /*yield*/, userInput()];
            case 5:
                _b = _d.sent(), oauthVerifier = _b.oauthVerifier, userName = _b.userName;
                if (!oauthVerifier || !userName) {
                    return [2 /*return*/];
                }
                return [4 /*yield*/, getAccessToken(oauthToken, oauthTokenSecret, oauthVerifier)];
            case 6:
                _c = _d.sent(), accessToken = _c.accessToken, accessTokenSecret = _c.accessTokenSecret;
                if (!(accessToken && accessTokenSecret)) return [3 /*break*/, 8];
                return [4 /*yield*/, setDb(db, accessToken, accessTokenSecret, userName)];
            case 7:
                _d.sent();
                return [3 /*break*/, 9];
            case 8: return [2 /*return*/];
            case 9: return [3 /*break*/, 11];
            case 10:
                e_1 = _d.sent();
                console.error(e_1.message);
                return [3 /*break*/, 11];
            case 11: return [2 /*return*/];
        }
    });
}); };
var logoutUser = function (db, user, path) { return __awaiter(void 0, void 0, void 0, function () {
    var err_5;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, new Promise(function () {
                        db.find({ _id: user }, function (err, result) {
                            console.log(result);
                            db.remove({ _id: user }, { multi: false }, function (e) {
                                if (!e) {
                                    console.log("Success: " + result.slice(-1)[0].name + "\u304B\u3089\u30ED\u30B0\u30A2\u30A6\u30C8\u3057\u307E\u3057\u305F");
                                }
                            });
                            if (result.slice(-1)[0].selected) {
                                db.find({ selected: false }, function (errr, selected) {
                                    db.update({ _id: selected.slice(-1)[0]._id }, {
                                        $set: {
                                            selected: true
                                        }
                                    }, {}, function () {
                                        var reload = new nedb_1["default"]({
                                            filename: path
                                        });
                                        reload.loadDatabase();
                                    });
                                });
                            }
                        });
                    })];
            case 1:
                _a.sent();
                return [2 /*return*/, true];
            case 2:
                err_5 = _a.sent();
                throw new Error('Error: 不明なエラー');
            case 3: return [2 /*return*/];
        }
    });
}); };
var selectedDeleteUser = function (selected) { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, user, err_6;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                onCancel = function () {
                    console.error('Error: 選択されませんでした');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'select',
                            name: 'user',
                            message: '削除したいアカウントを洗濯してください',
                            choices: selected
                        }
                    ], { onCancel: onCancel })];
            case 1:
                user = (_a.sent()).user;
                return [2 /*return*/, user];
            case 2:
                err_6 = _a.sent();
                throw new Error('Error: 選択されませんでした');
            case 3: return [2 /*return*/];
        }
    });
}); };
var findUsers = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var selectedUser, err_7;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, new Promise(function (resolve) {
                        db.find({}, function (err, result) {
                            var selectArray = [
                                {
                                    title: 'all',
                                    value: 'all'
                                }
                            ];
                            for (var i = 0; i < result.length; i += 1) {
                                selectArray.push({
                                    title: result[i].name,
                                    value: result[i]._id
                                });
                            }
                            resolve(selectArray);
                        });
                    })];
            case 1:
                selectedUser = _a.sent();
                return [2 /*return*/, selectedUser];
            case 2:
                err_7 = _a.sent();
                throw new Error('Error: パッケージに何か問題があるようです...databaseを削除すると直るかもしれません');
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.Logout = function (db, path) { return __awaiter(void 0, void 0, void 0, function () {
    var selectedArray, user, err_8;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 5, , 6]);
                return [4 /*yield*/, findUsers(db)];
            case 1:
                selectedArray = _a.sent();
                return [4 /*yield*/, selectedDeleteUser(selectedArray)];
            case 2:
                user = _a.sent();
                if (user === 'all') {
                    fs_1["default"].unlinkSync(path);
                    console.log('Success: 全てのアカウントからログアウトしました');
                    return [2 /*return*/];
                }
                if (!user) return [3 /*break*/, 4];
                return [4 /*yield*/, logoutUser(db, user, path)];
            case 3:
                if (_a.sent()) {
                    return [2 /*return*/];
                }
                _a.label = 4;
            case 4: return [2 /*return*/];
            case 5:
                err_8 = _a.sent();
                console.error(err_8.message);
                return [3 /*break*/, 6];
            case 6: return [2 /*return*/];
        }
    });
}); };
